/* Sistemas Integrados TECNISA
   Servios

Nome: ATUSALDO_EMPITEM

Descrio:
   Atualiza o saldo do empenho quando o item  excluido ou alterado.
Criao:
31/01/07 - Welbert G. Moitinha
@C:\web_605\sql\end_conv\oracle\2806_PEDTRGO_ATUSALDO_EMPITEM.SQL
*/

CREATE OR REPLACE TRIGGER ATUSALDO_EMPITEM
BEFORE INSERT OR UPDATE OR DELETE
ON ITEMPEDIDO FOR EACH ROW
DECLARE
   V_IDTABPRECO   VARCHAR2(1);
   V_IDUTCTRELANP VARCHAR2(1);
   V_IDUTCTREMPEN VARCHAR2(1);
   V_NREMPENHO EMPENHO.NREMPENHO%TYPE;
   V_CDCLIENTE CLIENTE.CDCLIENTE%TYPE;
   V_SALDOGERAL   FLOAT;
   V_IDTIPOPEDIDO VARCHAR2(1);
BEGIN
   V_IDTABPRECO   := '';
   V_IDUTCTRELANP := '';
   V_IDUTCTREMPEN := '';
   V_NREMPENHO    := '';
   V_CDCLIENTE    := '';
   V_SALDOGERAL   := 0;
   BEGIN
      SELECT P.IDTABPRECO, P.IDUTCTRELANP, PR.IDUTCTREMPEN
        INTO V_IDTABPRECO, V_IDUTCTRELANP, V_IDUTCTREMPEN
        FROM PARAMPEDIDO P, PARAMGERAL PR
       WHERE (P.CDFILIAL = NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDTABPRECO   := '';
         V_IDUTCTRELANP := '';
         V_IDUTCTREMPEN := '';
   END;

   IF (V_IDTABPRECO = '1') AND (V_IDUTCTREMPEN = 'S') AND (V_IDUTCTRELANP IN ('1','2')) THEN

      BEGIN
         SELECT P.NREMPENHO, P.CDCLIENTE, E.VRSALDOEMP, P.IDTIPOPEDIDO
         INTO V_NREMPENHO, V_CDCLIENTE, V_SALDOGERAL, V_IDTIPOPEDIDO
         FROM PEDIDO P, EMPENHO E
         WHERE P.CDCLIENTE = E.CDCLIENTE
           AND P.NREMPENHO = E.NREMPENHO
           AND NVL(:NEW.CDFILIAL, :OLD.CDFILIAL) = P.CDFILIAL
           AND NVL(:NEW.NRPEDIDO, :OLD.NRPEDIDO) = P.NRPEDIDO;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_NREMPENHO := '';
            V_CDCLIENTE := '';
      END;

      IF ((V_NREMPENHO IS NOT NULL) AND (V_IDTIPOPEDIDO = '1')) THEN
         IF (INSERTING) THEN
            IF (V_SALDOGERAL >= ((:NEW.QTITEMPED * :NEW.VRPREUNITPED)- NVL(:NEW.VRDESITPED,0)))THEN

               UPDATE EMPENHO
                  SET VRSALDOEMP  = ( VRSALDOEMP - ((:NEW.QTITEMPED * :NEW.VRPREUNITPED)- NVL(:NEW.VRDESITPED,0)))
                WHERE CDCLIENTE = V_CDCLIENTE
                  AND NREMPENHO = V_NREMPENHO;

            ELSE
               raise_application_error(-20501, 'SALDO_INSU', True);
            END IF;
         ELSE
            IF V_IDUTCTRELANP = '2' THEN
               IF (UPDATING) THEN
                  IF ((NOT :NEW.CDPRODUTO IS NULL) AND
                      (NOT :OLD.CDPRODUTO IS NULL) AND
                      (:NEW.CDPRODUTO <> :OLD.CDPRODUTO)) OR

                     ((NOT :NEW.QTITEMPED IS NULL) AND
                      (NOT :OLD.QTITEMPED IS NULL) AND
                      (:NEW.QTITEMPED <> :OLD.QTITEMPED)) OR

                     ((NOT :NEW.VRPREUNITPED IS NULL) AND
                      (NOT :OLD.VRPREUNITPED IS NULL) AND
                      (:NEW.VRPREUNITPED <> :OLD.VRPREUNITPED))THEN

                     UPDATE EMPENHO
                        SET VRSALDOEMP = ( VRSALDOEMP + ((:OLD.QTITEMPED * :OLD.VRPREUNITPED)- NVL(:OLD.VRDESITPED,0)))
                      WHERE CDCLIENTE = V_CDCLIENTE
                        AND NREMPENHO = V_NREMPENHO;

                     BEGIN
                        SELECT VRSALDOEMP
                          INTO V_SALDOGERAL
                          FROM EMPENHO
                         WHERE (CDCLIENTE = V_CDCLIENTE)
                           AND (NREMPENHO = V_NREMPENHO);
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_SALDOGERAL := 0;
                     END;

                     IF( V_SALDOGERAL >= ((:NEW.QTITEMPED * :NEW.VRPREUNITPED)- NVL(:NEW.VRDESITPED,0)))THEN
                        UPDATE EMPENHO
                        SET VRSALDOEMP = ( VRSALDOEMP - ((:NEW.QTITEMPED * :NEW.VRPREUNITPED)- NVL(:NEW.VRDESITPED,0)))
                        WHERE CDCLIENTE = V_CDCLIENTE
                          AND NREMPENHO = V_NREMPENHO;

                     ELSE
                        raise_application_error(-20501, 'SALDO_INSU');
                     END IF;
                  END IF;
               ELSE
                  IF(DELETING)AND( NOT V_NREMPENHO IS NULL) THEN
                     UPDATE EMPENHO
                     SET VRSALDOEMP = (VRSALDOEMP + ((:OLD.QTITEMPED * :OLD.VRPREUNITPED)- NVL(:OLD.VRDESITPED,0)))
                     WHERE CDCLIENTE = V_CDCLIENTE
                       AND NREMPENHO = V_NREMPENHO;
                  END IF;
               END IF;
            END IF;
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('ATUSALDO_EMPITEM','5.05.015'); END;
/

