CREATE OR REPLACE PROCEDURE DISTRIBUI_PRODUCAO(
P_OPERACAO IN VARCHAR2 /*G: gerao C: Cancelamento*/,
P_CDCENTRAL IN FILIAL.CDFILIAL%TYPE,
P_NRDISTPROD IN DISTPROD.NRDISTPROD%TYPE,
P_DTINI IN DATE,
P_DTFIN IN DATE,
P_NRLISTA_SERV  IN VARCHAR2,
P_CDOPERADOR IN VARCHAR2,
P_NRORG IN NUMBER,
P_RETORNO OUT VARCHAR2
)
AS
   V_CHAVE VARCHAR2(20);
   V_QTDECARD NUMBER;
   V_NRDISTPROD NUMBER;
   V_NRDISTCARD NUMBER;
   V_RETORNO VARCHAR2(400);
   V_MSGERRO VARCHAR2(400);
BEGIN
   IF P_OPERACAO = 'G' THEN
      /*Inclui registro da distribuio*/
      NOVO_CODIGO('DISTPROD', V_CHAVE, 1);
      V_NRDISTPROD := TO_NUMBER(V_CHAVE);
      
      INSERT INTO DISTPROD
      (NRDISTPROD, CDCENTRAL, DTINIPROD, DTFINPROD, NRORG)
      VALUES
      (V_NRDISTPROD, P_CDCENTRAL, P_DTINI, P_DTFIN, P_NRORG);
      
      V_QTDECARD := 0;
      /*Busca os cardpios contemplados pelo filtro informado*/
      FOR C_CARD IN
      (SELECT C.NRCARDAPIO, C.CDFILIAL, C.CDSERVFILI, C.DTCARDAPIO
         FROM CARDADIA C
              INNER JOIN LISTA LS ON LS.NRLISTA = P_NRLISTA_SERV AND
                                     SUBSTR(LS.CDLISTA, 1, 4) = C.CDFILIAL AND
                                     SUBSTR(LS.CDLISTA, 5, 5) = C.CDSERVFILI      
              LEFT JOIN CARDDISTPROD CD ON CD.CDFILIAL = C.CDFILIAL AND
                                           CD.NRCARDAPIO = C.NRCARDAPIO
              LEFT JOIN DISTCARD D ON D.CDFILIAL = C.CDFILIAL AND
                                      D.NRCARDAPIO = C.NRCARDAPIO
        WHERE C.DTCARDAPIO BETWEEN P_DTINI AND P_DTFIN
          AND CD.CDFILIAL IS NULL
          AND D.CDFILIAL IS NULL
          AND C.NRORG = P_NRORG
      ) LOOP
      
         /*Aplica a distribuio do cardpio (a nvel de servio)*/
         CALCULA_EMB_SERV(C_CARD.CDFILIAL, 
                          C_CARD.CDSERVFILI, 
                          C_CARD.DTCARDAPIO, 
                          NULL, 
                          NULL, 
                          'N', 
                          V_RETORNO
                         );
         /*Verifica se ocorreu algum erro durante o processo*/
         IF SUBSTR(V_RETORNO, 1, 4) = 'ERRO' THEN
             V_NRDISTCARD := NULL;
             V_MSGERRO := V_RETORNO;
         ELSE
             V_NRDISTCARD := TO_NUMBER(V_RETORNO);
             V_MSGERRO := NULL;
         END IF;
         
         /*Insere cardpio no controle da distribuio da produo*/
         INSERT INTO CARDDISTPROD
         (NRORG, NRDISTPROD, CDFILIAL, NRCARDAPIO, CDSERVFILI, NRDISTCARD, DSMENSAGEM)
         VALUES
         (P_NRORG, V_NRDISTPROD, C_CARD.CDFILIAL, C_CARD.NRCARDAPIO, C_CARD.CDSERVFILI, V_NRDISTCARD, V_MSGERRO);
         
         V_QTDECARD := V_QTDECARD + 1;
         
      END LOOP;
      
      /*Se nenhum cardpio foi contemplado pelos filtros da procedure, apaga
        a distribuio*/
      IF V_QTDECARD = 0 THEN 
         
         DELETE FROM DISTPROD 
         WHERE NRDISTPROD = V_NRDISTPROD
           AND NRORG = P_NRORG;
         
         V_NRDISTPROD := 0;
      END IF;
      
      /*Retorna a chave da distribuio da produo*/
      P_RETORNO := TO_CHAR(V_NRDISTPROD);
   
   /*Excluso da distribuio da produo*/
   ELSE
      /*Apaga cada uma das distribuies dos cardpios distribudos*/
      FOR C_CARD IN
      (SELECT NRDISTCARD
         FROM CARDDISTPROD
        WHERE NRDISTPROD = P_NRDISTPROD
          AND NRDISTCARD IS NOT NULL
          AND NRORG = P_NRORG
      ) LOOP
         DELETE FROM ITEMBDISTCARD
          WHERE NRDISTCARD = C_CARD.NRDISTCARD
            AND NRORG = P_NRORG;
         
         DELETE FROM EMBDISTCARD
          WHERE NRDISTCARD = C_CARD.NRDISTCARD
            AND NRORG = P_NRORG;
         
         DELETE FROM CNFDISTCARD
          WHERE NRDISTCARD = C_CARD.NRDISTCARD
            AND NRORG = P_NRORG;
         
         DELETE FROM DISTCARD
          WHERE NRDISTCARD = C_CARD.NRDISTCARD
            AND NRORG = P_NRORG;
      END LOOP;
      
      /*Apaga os itens da distribuio da produo*/
      DELETE FROM CARDDISTPROD
       WHERE NRDISTPROD = P_NRDISTPROD 
         AND NRORG = P_NRORG;

      /*Apaga a distribuio da produo*/
      DELETE FROM DISTPROD
       WHERE NRDISTPROD = P_NRDISTPROD
         AND NRORG = P_NRORG;
   END IF;
   
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DISTRIBUI_PRODUCAO','6.05.000'); END;
/

