IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_VALIDANFTPOP' AND
                 TYPE = 'TR' 		                AND
	              U.UID = O.UID                   AND
	              U.NAME = USER)
DROP TRIGGER LOG_VALIDANFTPOP
GO


CREATE  TRIGGER LOG_VALIDANFTPOP
ON VALIDANFTPOP
FOR INSERT,UPDATE,DELETE
AS
   DECLARE  @V_USUARIO   VARCHAR(40);
   DECLARE  @V_TIPO      VARCHAR(1);
   DECLARE  @V_ITPESQ    VARCHAR(40);
   DECLARE  @V_DESC      VARCHAR(300);
   DECLARE @V_DSREMOTEADDR     VARCHAR(15);
   DECLARE @V_DSREMOTEHOST     VARCHAR(15);
   DECLARE @V_DSSERVERRDM      VARCHAR(20);
   DECLARE @V_DSSERVMETHOD     VARCHAR(30);
   DECLARE @V_DSREMOTEOPER     VARCHAR(12);
/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO          VARCHAR(1);
   DECLARE @V_CDTIPOOPER_OLD      VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_OLD    VARCHAR(1);
   DECLARE @V_IDINSCESTAIGU_OLD   VARCHAR(1);
   DECLARE @V_IDINSCESTADIF_OLD   VARCHAR(1);
   DECLARE @V_CDTIPOOPER_NEW      VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_NEW    VARCHAR(1);
   DECLARE @V_IDINSCESTAIGU_NEW   VARCHAR(1);
   DECLARE @V_IDINSCESTADIF_NEW   VARCHAR(1);
BEGIN

   SET @V_DESC     = '';
   SET @V_TIPO     = '0';

   EXEC NMUSUARIO @V_USUARIO OUTPUT;
   SET @V_USUARIO = ISNULL(@V_USUARIO, ' ');
   EXEC WEBTUNNING @V_DSREMOTEADDR OUTPUT,
                   @V_DSREMOTEHOST OUTPUT,
                   @V_DSSERVERRDM OUTPUT,
                   @V_DSSERVMETHOD OUTPUT,
                   @V_DSREMOTEOPER OUTPUT;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         DELETED.CDTIPOOPER,
         DELETED.IDENTRSAIDOP,
         DELETED.IDINSCESTAIGU,
         DELETED.IDINSCESTADIF,
         NULL,
         NULL,
         NULL,
         NULL
   FROM
      DELETED
   WHERE
        0 = (SELECT COUNT(*) FROM INSERTED)

   UNION ALL

   SELECT
      'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         INSERTED.CDTIPOOPER,
         INSERTED.IDENTRSAIDOP,
         INSERTED.IDINSCESTAIGU,
         INSERTED.IDINSCESTADIF
   FROM
      INSERTED
   WHERE
     0 = (SELECT COUNT(*) FROM DELETED)


   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                 @V_CDTIPOOPER_OLD,
                                 @V_IDENTRSAIDOP_OLD,
                                 @V_IDINSCESTAIGU_OLD,
                                 @V_IDINSCESTADIF_OLD,
                                 @V_CDTIPOOPER_NEW,
                                 @V_IDENTRSAIDOP_NEW,
                                 @V_IDINSCESTAIGU_NEW,
                                 @V_IDINSCESTADIF_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO= 'D' /*DELETING*/ BEGIN
         IF @V_CDTIPOOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'TpOper=' + @V_CDTIPOOPER_OLD;
         END;
         IF @V_IDENTRSAIDOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' E/S=' + @V_IDENTRSAIDOP_OLD;
         END;
         IF @V_IDINSCESTAIGU_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Insc.Igu=' + @V_IDINSCESTAIGU_OLD;
         END;
         IF @V_IDINSCESTADIF_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' Insc.Dif=' +@V_IDINSCESTADIF_OLD;
         END;

         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_CDTIPOOPER_OLD;
      END
      ELSE BEGIN
         IF @V_ID_COMANDO= 'I' BEGIN
            IF ISNULL(@V_CDTIPOOPER_OLD, '!') <> ISNULL(@V_CDTIPOOPER_NEW, '!')  BEGIN
               SET @V_DESC = @V_DESC + 'TpOper=' + @V_CDTIPOOPER_NEW;
            END;
            IF ISNULL(@V_IDENTRSAIDOP_OLD, '!') <> ISNULL(@V_IDENTRSAIDOP_NEW, '!') BEGIN
               SET @V_DESC = @V_DESC + ' E/S=' + @V_IDENTRSAIDOP_NEW;
            END;
            IF ISNULL(@V_IDINSCESTAIGU_OLD, '!') <> ISNULL(@V_IDINSCESTAIGU_NEW, '!') BEGIN
               SET @V_DESC = @V_DESC + ' Insc.Igu=' + @V_IDINSCESTAIGU_NEW;
            END;
            IF ISNULL(@V_IDINSCESTADIF_OLD, '!') <> ISNULL(@V_IDINSCESTADIF_NEW, '!') BEGIN
               SET @V_DESC = @V_DESC + ' Insc.Dif=' +@V_IDINSCESTADIF_NEW;
            END;

            SET @V_TIPO = '1';
            SET @V_ITPESQ = @V_CDTIPOOPER_NEW;
         END;
      END;

      IF (@V_TIPO <> '0')  BEGIN
         IF NOT @V_DESC IS NULL BEGIN
            INSERT INTO LOGOPERA
                     (NMTABELA, DTOPERACAO,NMRESPOPER, IDTIPOOPER, CDPESQITEM,DSOPERACAO,
                     DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
               VALUES
                     ('VALIDANFTPOP', GETDATE(), @V_USUARIO, @V_TIPO, @V_ITPESQ, @V_DESC,
                     @V_DSREMOTEADDR, @V_DSREMOTEHOST, @V_DSSERVERRDM, @V_DSSERVMETHOD, @V_DSREMOTEOPER);
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                    @V_CDTIPOOPER_OLD,
                                    @V_IDENTRSAIDOP_OLD,
                                    @V_IDINSCESTAIGU_OLD,
                                    @V_IDINSCESTADIF_OLD,
                                    @V_CDTIPOOPER_NEW,
                                    @V_IDENTRSAIDOP_NEW,
                                    @V_IDINSCESTAIGU_NEW,
                                    @V_IDINSCESTADIF_NEW;
   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'LOG_VALIDANFTPOP','5.42.xxx';
GO
